; =========================================================================

    .686P                       ; processor model
    .MODEL FLAT, STDCALL        ; memory model & calling convention
    OPTION CASEMAP :NONE        ; case sensitive

  ; Author Jake Commander
  ; Copyright The GeneSys Development System

    include \genesys\include\windows.inc
    include \genesys\include\kernel32.inc

    conin PROTO :DWORD,:DWORD

    .code

; =========================================================================

conin proc lpbuffer:DWORD,bufflen:DWORD

  ; -----------------------------------------------------------
  ; lpbuffer should be 260 bytes on win2k and later os versions
  ; -----------------------------------------------------------
    LOCAL stdhandle :DWORD
    LOCAL readcount :DWORD

    invoke GetStdHandle,STD_INPUT_HANDLE
    mov stdhandle, eax

    invoke SetConsoleMode,stdhandle,ENABLE_LINE_INPUT or \
                                    ENABLE_ECHO_INPUT or \
                                    ENABLE_PROCESSED_INPUT

    invoke ReadFile,stdhandle,lpbuffer,bufflen,ADDR readcount,NULL

  ; ---------------
  ; strip CRLF pair
  ; ---------------
    mov eax, lpbuffer
    sub eax, 1
  @@:
    add eax, 1
    cmp BYTE PTR [eax], 0
    jz @F
    cmp BYTE PTR [eax], 13
    je @F
    cmp BYTE PTR [eax], 10
    ja @B

  @@:
    mov BYTE PTR [eax], 0
    sub eax, lpbuffer

    ret

conin endp

; =========================================================================

    end