; =========================================================================

      .686P                         ; processor model
      .MODEL FLAT, STDCALL          ; memory model & calling convention
      OPTION CASEMAP :NONE          ; case sensitive

    ; Author Jake Commander
    ; Copyright The GeneSys Development System
    ; overwrite existing string with lower case characters.

      LowerCase PROTO :DWORD

      .code

; =========================================================================

OPTION PROLOGUE:NONE                ; turn of stack frame generation
OPTION EPILOGUE:NONE 

align 4

LowerCase proc lpstring:DWORD

        mov     eax, [esp+4]
        sub     eax, 1
    procin:
        add     eax, 1
        movzx   ecx, BYTE PTR [eax] ; one memory access for testing byte
        test    ecx, ecx
        jz      procout
        cmp     ecx, 65
        jb      procin
        cmp     ecx, 90
        ja      procin
        add     BYTE PTR [eax], 32  ; one memory access for changing byte
        jmp     procin
    procout:
        mov     eax, [esp+4]        ; return value for macro
        ret     4

LowerCase endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; =========================================================================

end
